package com.gjz.xiaoheizi.config;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.cors.CorsConfiguration;
import org.springframework.web.cors.UrlBasedCorsConfigurationSource;
import org.springframework.web.filter.CorsFilter;

/**
 * @author Guan
 * @date 2022/10/13
 * discription
 */
@Configuration
public class CorsConfig {
    private static final long MAX_AGE = 24 * 60 *60;

    @Value("${localhost.frontUrl}")
    private String frontUrl;
    @Bean
    public CorsFilter corsFilter(){
        UrlBasedCorsConfigurationSource source = new UrlBasedCorsConfigurationSource();
        CorsConfiguration corsConfiguration = new CorsConfiguration();
        corsConfiguration.addAllowedOrigin(frontUrl);//"http://192.168.0.177:8080"
        //corsConfiguration.addAllowedOrigin("http://192.168.0.160:8080");//"http://192.168.0.177:8080"
        corsConfiguration.setAllowCredentials(true);
        corsConfiguration.addAllowedHeader("*");
        corsConfiguration.addAllowedMethod("*");
        corsConfiguration.setMaxAge(MAX_AGE);
        source.registerCorsConfiguration("/**",corsConfiguration);
        return new CorsFilter(source);
    }
}
