package com.gjz.xiaoheizi.controller;

import com.gjz.xiaoheizi.entity.Banner;
import com.gjz.xiaoheizi.entity.Files;
import com.gjz.xiaoheizi.mapper.BannerMapper;
import com.gjz.xiaoheizi.service.BannerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;

import java.io.File;
import java.util.List;

/**
 * @author Guan
 * @date 2023/2/21
 * discription
 */
@RestController
@RequestMapping("/banner")
public class BannerController {

    @Autowired
    private BannerMapper bannerMapper;

    @Autowired
    private BannerService bannerService;

    @PostMapping("/files")
    private boolean saveOne(@RequestBody Banner banner){
        return bannerService.save(banner);
    }

    //返回图片path
    @GetMapping("/files")
    public List<Files> findAllFilesPath(){
        return bannerMapper.findAllFilesPath();
    }

    //删除单张图片
    @Value("${files.upload.path}")
    private String fileUploadPath;
    @Value("${files.upload.urlhead}")
    private String urlHead;
    @DeleteMapping("/icon/{fileUUID}")
    public boolean deleteIcon(@PathVariable String fileUUID){
        String url= fileUploadPath+ fileUUID;
        File file = new File(url);
        boolean isOK = file.exists();
        if (isOK){
            file.delete();
            String path = urlHead + fileUUID;
            bannerMapper.deleteByPath(path);
//            System.out.println("122222222222222222222222222222");
            return true;
        }else{
            return false;
        }
    }
}
