package com.gjz.xiaoheizi.controller;

import com.gjz.xiaoheizi.controller.dto.FilesDto;
import com.gjz.xiaoheizi.entity.Files;
import com.gjz.xiaoheizi.mapper.FilesMapper;
import com.gjz.xiaoheizi.service.FilesService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;

import java.io.File;
import java.util.List;

/**
 * @author Guan
 * @date 2022/10/20
 * discription
 */
@RestController
@RequestMapping("/files")
public class FilesController {
    @Autowired
    private FilesService filesService;

    @Autowired
    private FilesMapper filesMapper;

    @GetMapping("/{id}")
    public List<Files> findAllFilesPath(@PathVariable Integer id){
        return filesMapper.findByIdFiles(id);
    }

    @PostMapping
    public boolean save(@RequestBody FilesDto filesDto){
        return filesMapper.saveOne(filesDto);
    }


    @Value("${files.upload.path}")
    private String fileUploadPath;

    @Value("${files.upload.urlhead}")
    private String urlHead;

    @DeleteMapping("/{fileUUID}")
    public boolean delete(@PathVariable String fileUUID){
        String url= fileUploadPath+ fileUUID;
        File file = new File(url);
        boolean isOK = file.exists();
        if (isOK){
            file.delete();
            String path = urlHead + fileUUID;
            filesMapper.deleteByPath(path);
            return true;
        }else{
            return false;
        }
    }

    @DeleteMapping("/delBatch/{merchantId}")
    public boolean deleteBatch(@PathVariable String merchantId){
        List<FilesDto> fileUUIDList = filesMapper.getFileUUIDList(merchantId);
        System.out.println(fileUUIDList);
        for (int i = 0 ; i < fileUUIDList.size() ; i ++){
            String iPath = fileUUIDList.get(i).getIconPath().substring(31);
            String url= fileUploadPath + iPath;
            File file = new File(url);
            boolean isOK = file.exists();
            if (isOK){
                file.delete();
            }

        }
        return filesMapper.removeByMerchantId(merchantId);
    }
}
