package com.gjz.xiaoheizi.controller;

import com.gjz.xiaoheizi.controller.dto.MerchantDto;
import com.gjz.xiaoheizi.controller.dto.NotificationDto;
import com.gjz.xiaoheizi.controller.dto.ScenicSpotDto;
import com.gjz.xiaoheizi.controller.dto.StrategyDto;
import com.gjz.xiaoheizi.entity.Files;
import com.gjz.xiaoheizi.entity.Introduce;
import com.gjz.xiaoheizi.entity.Merchant;
import com.gjz.xiaoheizi.entity.ScenicSpot;
import com.gjz.xiaoheizi.mapper.*;
import com.gjz.xiaoheizi.service.IntroduceService;
import com.gjz.xiaoheizi.service.MerchantService;
import com.gjz.xiaoheizi.service.ScenicSpotService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

/**
 * @author Guan
 * @date 2023/2/2
 * discription
 */
@RestController
@RequestMapping("/front")
public class FrontController {

    @Autowired
    private ScenicSpotService scenicSpotService;

    @Autowired
    private ScenicSpotMapper scenicSpotMapper;

    @Autowired
    private MerchantService merchantService;

    @Autowired
    private MerchantMapper merchantMapper;

    @Autowired
    private FilesMapper filesMapper;

    @Autowired
    private IntroduceService introduceService;

    @Autowired
    private IntroduceMapper introduceMapper;

    @Autowired
    private NotificationMapper notificationMapper;

    @Autowired
    private StrategyMapper strategyMapper;

    @Autowired
    private BannerMapper bannerMapper;


    //景点点击量++
    @ApiOperation("景点点击量++")
    @GetMapping("/scenicSpot/{id}")
    public boolean scenicSpotViewCountAdd(@PathVariable Integer id){
        ScenicSpot byId = scenicSpotService.getById(id);
        byId.setViewCount(byId.getViewCount() + 1);
        scenicSpotService.saveOrUpdate(byId);
        return true;
    }

    //商户点击量++
    @ApiOperation("商户点击量++")
    @GetMapping("/merchant/{id}")
    public boolean merchantViewCountAdd(@PathVariable Integer id){
        Merchant byId = merchantService.getById(id);
        byId.setViewCount(byId.getViewCount() + 1);
        merchantService.saveOrUpdate(byId);
        return true;
    }

    //获取所有商户详情信息
    @ApiOperation("获取所有商户详情信息")
    @GetMapping("/merchantAndCallout")
    public List<MerchantDto> getAllMerchantAndCallout(){
        List<Merchant> idList = merchantService.list();
        List<MerchantDto> merchantDtos = new ArrayList<>();
        for (int i = 0; i < idList.size(); i++) {
            Integer id = idList.get(i).getId();
            MerchantDto byId = merchantMapper.findById(id);
            merchantDtos.add(byId);
        }
        return merchantDtos;
    }
    //获取商户照片路径list
    @ApiOperation("获取商户照片list")
    @GetMapping("/findAllMerchantFilesPath/{id}")
    public List<Files> findAllMerchantFilesPath(@PathVariable Integer id){
        return filesMapper.findByIdFiles(id);
    }

    //获取所有景点详情信息
    @ApiOperation("获取所有景点详情信息")
    @GetMapping("/scenicSpotAndCallout")
    public List<ScenicSpotDto> getAllScenicSpotAndCallout(){
        List<ScenicSpot> idList = scenicSpotService.list();
        List<ScenicSpotDto> scenicSpotDtos = new ArrayList<>();
        for (int i = 0;i <idList.size() ; i++){
            Integer id = idList.get(i).getId();
            ScenicSpotDto byId = scenicSpotMapper.findById(id);
            scenicSpotDtos.add(byId);
        }
        return scenicSpotDtos;
    }

    //获取景点照片路径list
    @GetMapping("/findAllScenicSpotFilesPath/{id}")
    public List<Files> findAllScenicSpotFilesPath(@PathVariable Integer id){
        return scenicSpotMapper.findByIdFiles(id);
    }

    //获取景点简介信息
    @GetMapping("/introduce/{id}")
    public Introduce getIntroduce(@PathVariable Integer id) {
        return introduceService.getById(id);
    }
    //获取景点简介图片
    @GetMapping("/introduce/files/{id}")
    public List<Files> findAllFilesPath(@PathVariable Integer id){
        return introduceMapper.findByIdFiles(id);
    }


    //获取所有通告
    @GetMapping("/notificationFront")
    public List<NotificationDto> notificationFront(){
        return notificationMapper.getAllNotification();
    }

    //获取所有攻略
    @GetMapping("/strategyFront")
    public List<StrategyDto> strategyFront(){
        return strategyMapper.getAllStrategy();
    }

    //返回图片banner path
    @GetMapping("/banner")
    public List<Files> findAllFilesPath(){
        return bannerMapper.findAllFilesPath();
    }
}

