package com.gjz.xiaoheizi.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gjz.xiaoheizi.controller.dto.IntroduceFilesDto;
import com.gjz.xiaoheizi.entity.Files;
import com.gjz.xiaoheizi.entity.Introduce;
import com.gjz.xiaoheizi.mapper.IntroduceMapper;
import com.gjz.xiaoheizi.service.IntroduceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;

import java.io.File;
import java.util.List;

/**
 * @author Guan
 * @date 2022/10/31
 * discription
 */
@RestController
@RequestMapping("/introduce")
public class IntroduceController {
    @Autowired
    private IntroduceService introduceService;

    @Autowired
    private IntroduceMapper introduceMapper;

    @GetMapping("/page")
    public IPage<Introduce> findPage(@RequestParam Integer pageNum,
                                     @RequestParam Integer pageSize,
                                     @RequestParam(defaultValue = "") String title) {
        IPage<Introduce> page = new Page<>(pageNum, pageSize);
        QueryWrapper<Introduce> queryWrapper = new QueryWrapper<>();
        if (!"".equals(title)) {
            queryWrapper.like("title", title);
        }

        return introduceService.page(page, queryWrapper);
    }

    //新增和修改
    @PostMapping
    public boolean save(@RequestBody Introduce introduce) {
        return introduceService.updateById(introduce);
    }

    @GetMapping("/{id}")
    public Introduce getIntroduce(@PathVariable Integer id){
        return introduceService.getById(id);
    }
    /////////////////////////
    @GetMapping("/files/{id}")
    public List<Files> findAllFilesPath(@PathVariable Integer id){
        return introduceMapper.findByIdFiles(id);
    }

    @PostMapping("/files")
    public boolean saveFiles(@RequestBody IntroduceFilesDto introduceFilesDto){
        return introduceMapper.saveOne(introduceFilesDto);
    }

    @Value("${files.upload.path}")
    private String fileUploadPath;
    @Value("${files.upload.urlhead}")
    private String urlHead;

    @DeleteMapping("/{fileUUID}")
    public boolean delete(@PathVariable String fileUUID){
        String url= fileUploadPath+ fileUUID;
        File file = new File(url);
        boolean isOK = file.exists();
        if (isOK){
            file.delete();
            String path = urlHead + fileUUID;
            introduceMapper.deleteByPath(path);
            return true;
        }else{
            return false;
        }
    }



}
