package com.gjz.xiaoheizi.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gjz.xiaoheizi.controller.dto.NotificationFilesDto;
import com.gjz.xiaoheizi.controller.dto.StrategyFilesDto;
import com.gjz.xiaoheizi.entity.Files;
import com.gjz.xiaoheizi.entity.Notification;
import com.gjz.xiaoheizi.entity.Strategy;
import com.gjz.xiaoheizi.mapper.StrategyFilesMapper;
import com.gjz.xiaoheizi.mapper.StrategyMapper;
import com.gjz.xiaoheizi.service.StrategyFilesService;
import com.gjz.xiaoheizi.service.StrategyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;

import java.io.File;
import java.util.List;

/**
 * @author Guan
 * @date 2023/2/17
 * discription
 */
@RestController
@RequestMapping("/strategy")
public class StrategyController {
    @Autowired
    private StrategyService strategyService;

    @Autowired
    private StrategyMapper strategyMapper;

    @Autowired
    private StrategyFilesService strategyFilesService;

    @Autowired
    private StrategyFilesMapper strategyFilesMapper;


    @GetMapping("/page")
    public IPage<Strategy> findPage(@RequestParam Integer pageNum,
                                    @RequestParam Integer pageSize,
                                    @RequestParam(defaultValue = "") String title) {
        IPage<Strategy> page = new Page<>(pageNum, pageSize);
        QueryWrapper<Strategy> queryWrapper = new QueryWrapper<>();
        if (!"".equals(title)) {
            queryWrapper.like("title", title);
        }

        return strategyService.page(page, queryWrapper);
    }

    //新增和修改
    @PostMapping("/save")
    public boolean save(@RequestBody Strategy strategy) {
        boolean b = strategyService.saveOrUpdate(strategy);
        return b;
    }

    //修改标志位
    @GetMapping("/status/{id}")
    public void statusChange(@PathVariable Integer id){
        Strategy byId = strategyService.getById(id);
        int status = byId.getStatus();
        if (status == 0){
            status = 1;
        }else {
            status = 0;
        }
        byId.setStatus(status);
        strategyService.updateById(byId);
    }

    //删除
    @DeleteMapping("/{id}")
    public boolean delete(@PathVariable Integer id){
        return strategyService.removeById(id);
    }

    @DeleteMapping("/delicon/{strategyId}")
    public boolean deleteone(@PathVariable String strategyId){
        List<StrategyFilesDto> fileUUIDList = strategyFilesMapper.getFileUUIDList(strategyId);
        System.out.println(fileUUIDList);
        for (int i = 0 ; i < fileUUIDList.size() ; i ++){
            String iPath = fileUUIDList.get(i).getIconPath().substring(31);
            String url= fileUploadPath + iPath;
            File file = new File(url);
            boolean isOK = file.exists();
            if (isOK){
                file.delete();
            }

        }
        return strategyFilesMapper.removeByScenicspotId(strategyId);
    }


    @Value("${files.upload.path}")
    private String fileUploadPath;
    //删除单张图片
    @Value("${files.upload.urlhead}")
    private String urlHead;
    @DeleteMapping("/icon/{fileUUID}")
    public boolean deleteIcon(@PathVariable String fileUUID){
        String url= fileUploadPath+ fileUUID;
        File file = new File(url);
        boolean isOK = file.exists();
        if (isOK){
            file.delete();
            String path = urlHead + fileUUID;
            strategyMapper.deleteByPath(path);
            System.out.println("122222222222222222222222222222");
            return true;
        }else{
            return false;
        }
    }

    //上传图片
    @PostMapping("/files")
    public boolean saveFiles(@RequestBody StrategyFilesDto strategyFilesDto){
        return strategyMapper.saveOne(strategyFilesDto);
    }

    //返回图片path
    @GetMapping("/files/{id}")
    public List<Files> findAllFilesPath(@PathVariable Integer id){
        return strategyMapper.findByIdFiles(id);
    }






}
