package com.gjz.xiaoheizi.filter;

import com.alibaba.fastjson.JSON;
import com.gjz.xiaoheizi.common.JwtUtils;
import com.gjz.xiaoheizi.common.R;
import lombok.extern.slf4j.Slf4j;
import org.springframework.util.AntPathMatcher;
import org.springframework.web.bind.annotation.CrossOrigin;

import javax.servlet.*;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * @author Guan
 * @date 2023/1/28
 * discription
 */
@CrossOrigin
@WebFilter(filterName = "loginCheckFilter",urlPatterns = "/*")
@Slf4j
public class LoginCheckFilter implements Filter {
    public static final AntPathMatcher PATH_MATCHER = new AntPathMatcher();
    @Override
    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain) throws IOException, ServletException {
        HttpServletRequest request = (HttpServletRequest) servletRequest;
        HttpServletResponse response = (HttpServletResponse) servletResponse;

        //1.获取本次请求的URI
        String requestURI = request.getRequestURI();
        System.out.println(requestURI);

        //定义不需要处理的请求路径
        String[] urls = new String[]{
                "/file/**",
                "/files/**",
//                "/introduce//files/{id}",
                "/user/login",
                "/user/logout",
                "/front/**",
        };


        //2.判断本次请求是否需要处理
        boolean check = check(urls, requestURI);

        //3.如果不需要处理，则直接放行
        if (check){
            System.out.println("放行");
            filterChain.doFilter(request,response);
            return;
        }

        //4.判断登录状态，如果已经登录，则直接放行\

//        System.out.println(request.getHeader("token"));
//        System.out.println(request.getHeader("Accept"));
//        System.out.println(JwtUtils.checkToken(request));
        if (JwtUtils.checkToken(request)){
            System.out.println("1111111111111111111111111");
            filterChain.doFilter(request,response);
            return;
        }

        //OPTIONS里不含token，跳过OPTIONS请求
        String method = request.getMethod();
        if ("OPTIONS".equals(method)) {
            filterChain.doFilter(request,response);
            return;
        }

        //5.如果未登录则返回未登录结果,通过输出流方式向客户端页面响应数据
        response.setCharacterEncoding("UTF-8");
        response.setHeader("Access-Control-Allow-Origin", "*");
        response.setHeader("Access-Control-Allow-Methods", "GET,POST");
        response.getWriter().write(JSON.toJSONString(R.error().message("NOTLOGIN")));
        System.out.println("123");


    }

    /**
     * 路径匹配,检查本次请求是否需要放行
     * @param requestURI
     * @return
     */
    public boolean check(String[] urls,String requestURI){
        for (String url : urls) {
            boolean match = PATH_MATCHER.match(url, requestURI);
            if (match){
                return true;
            }
        }
        return false;
    }
}
