package com.gjz.xiaoheizi.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gjz.xiaoheizi.controller.dto.FilesDto;
import com.gjz.xiaoheizi.entity.Files;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * @author Guan
 * @date 2022/10/20
 * discription
 */
public interface FilesMapper extends BaseMapper<Files> {

    @Select("SELECT f.icon_path FROM sys_merchant AS m INNER JOIN sys_files AS f ON m.id = f.merchant_id AND m.id = #{id}")
    List<Files> findByIdFiles(@Param("id") Integer id);

    @Insert("insert into sys_files(merchant_id, icon_path) values (#{merchantId},#{iconPath})")
    boolean saveOne(FilesDto filesDto);

    @Delete("delete from sys_files where icon_path = #{path}")
    void deleteByPath(String path);

    @Delete("delete from sys_files where merchant_id = #{merchantId}")
    boolean removeByMerchantId(String merchantId);

    @Select("select icon_path from sys_files where merchant_id = #{merchantId}")
    List<FilesDto> getFileUUIDList(String merchantId);
    //1
}
