package com.gjz.xiaoheizi.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gjz.xiaoheizi.controller.dto.FilesDto;
import com.gjz.xiaoheizi.controller.dto.IntroduceFilesDto;
import com.gjz.xiaoheizi.entity.Files;
import com.gjz.xiaoheizi.entity.Introduce;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * @author Guan
 * @date 2022/10/31
 * discription
 */
public interface IntroduceMapper extends BaseMapper<Introduce> {
    @Select("SELECT f.icon_path FROM sys_introduce AS i INNER JOIN sys_introducefiles AS f ON i.id = f.introduce_id AND i.id = #{id}")
    List<Files> findByIdFiles(@Param("id") Integer id);

    @Insert("insert into sys_introducefiles(introduce_id, icon_path) values (#{introduceId},#{iconPath})")
    boolean saveOne(IntroduceFilesDto introduceFilesDto);

    @Delete("delete from sys_introducefiles where icon_path = #{path}")
    void deleteByPath(String path);
}
