package com.gjz.xiaoheizi.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gjz.xiaoheizi.controller.dto.NotificationDto;
import com.gjz.xiaoheizi.controller.dto.NotificationFilesDto;
import com.gjz.xiaoheizi.entity.Files;
import com.gjz.xiaoheizi.entity.Notification;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * @author Guan
 * @date 2023/2/9
 * discription
 */
public interface NotificationMapper extends BaseMapper<Notification> {
    @Insert("insert into sys_notificationfiles(notification_id, icon_path) values (#{notificationId},#{iconPath})")
    boolean saveOne(NotificationFilesDto notificationFilesDto);

    @Select("SELECT f.icon_path FROM sys_notification AS i INNER JOIN sys_notificationfiles AS f ON i.id = f.notification_id AND i.id = #{id}")
    List<Files> findByIdFiles(@Param("id") Integer id);

    List<NotificationDto> getAllNotification();

    @Delete("delete from sys_notificationfiles where icon_path = #{path}")
    void deleteByPath(String path);
}
