package com.gjz.xiaoheizi.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gjz.xiaoheizi.controller.dto.ScenicSpotDto;
import com.gjz.xiaoheizi.controller.dto.ScenicSpotFilesDto;
import com.gjz.xiaoheizi.entity.Files;
import com.gjz.xiaoheizi.entity.ScenicSpot;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * @author Guan
 * @date 2023/2/2
 * discription
 */
public interface ScenicSpotMapper extends BaseMapper<ScenicSpot> {

    @Select("SELECT * FROM `sys_scenicspot` WHERE title=#{title}")
    ScenicSpot findByTitle(ScenicSpot scenicSpot);

    @Insert("insert into sys_scenicspotfiles(scenicspot_id, icon_path) values (#{scenicspotId},#{iconPath})")
    boolean saveOneFile(ScenicSpotFilesDto scenicSpotFilesDto);

    @Delete("delete from sys_scenicspotfiles where icon_path = #{path}")
    void deleteByPath(String path);

    @Select("SELECT f.icon_path FROM sys_scenicspot AS i INNER JOIN sys_scenicspotfiles AS f ON i.id = f.scenicspot_id AND i.id = #{id}")
    List<Files> findByIdFiles(@Param("id") Integer id);

    ScenicSpotDto findById(@Param("id") Integer id);
}
