package com.gjz.xiaoheizi.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.gjz.xiaoheizi.controller.dto.NotificationFilesDto;
import com.gjz.xiaoheizi.controller.dto.StrategyDto;
import com.gjz.xiaoheizi.controller.dto.StrategyFilesDto;
import com.gjz.xiaoheizi.entity.Files;
import com.gjz.xiaoheizi.entity.Strategy;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * @author Guan
 * @date 2023/2/17
 * discription
 */
public interface StrategyMapper extends BaseMapper<Strategy> {

    @Insert("insert into sys_strategyfiles(strategy_id, icon_path) values (#{strategyId},#{iconPath})")
    boolean saveOne(StrategyFilesDto strategyFilesDto);


    @Select("SELECT f.icon_path FROM sys_strategy AS i INNER JOIN sys_strategyfiles AS f ON i.id = f.strategy_id AND i.id = #{id}")
    List<Files> findByIdFiles(Integer id);

    @Delete("delete from sys_strategyfiles where icon_path = #{path}")
    void deleteByPath(String path);

    List<StrategyDto> getAllStrategy();
}
