package com.gjz.xiaoheizi.service;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gjz.xiaoheizi.controller.dto.UserDto;
import com.gjz.xiaoheizi.entity.User;
import com.gjz.xiaoheizi.mapper.UserMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.DigestUtils;

import javax.print.ServiceUI;

/**
 * @author Guan
 * @date 2022/10/12
 * discription
 */
@Service
public class UserService extends ServiceImpl<UserMapper,User> {
    public boolean saveUser(User user) {
        return saveOrUpdate(user);
    }

    public boolean login(UserDto userDto) {
        //1、将页面提交的密码进行md5加密处理
        String password = userDto.getPassword();
        password = DigestUtils.md5DigestAsHex(password.getBytes());

        //2、根据页面提交的用户名查询数据库
        QueryWrapper<User> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("username",userDto.getUsername());
        queryWrapper.eq("password",password);
        User one = getOne(queryWrapper);
        return one != null;
    }
}
